-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["SHAMAN"] = {}
lib.classes["SHAMAN"][2] = function()
	cfg.Sets={}
	cfg.Sets["T10Enh"] = {50830,50831,50832,50833,50834,51195,51196,51197,51198,51199,51240,51241,51242,51243,51244}
	cfg.SetItems = {}
		
	cfg.spells={}
	lib.AddSpell(Heddframe,cfg.spells,"ss",{17364,73899}) -- SS PS
	lib.AddSpell(Heddframe,cfg.spells,"melee",{6603}) -- Melee
	lib.AddSpell(Heddframe,cfg.spells,"es",{8042}) -- ES
	lib.AddSpell(Heddframe,cfg.spells,"fs",{8050}) -- FS
	lib.AddSpell(Heddframe,cfg.spells,"ll",{60103}) -- LL
	lib.AddSpell(Heddframe,cfg.spells,"fn",{1535}) -- FN
	lib.AddSpell(Heddframe,cfg.spells,"sr",{30823}) -- SR
	lib.AddSpell(Heddframe,cfg.spells,"sw",{51533}) -- Spirit Wolfs
	lib.AddSpell(Heddframe,cfg.spells,"ls",{324}) -- LS
	lib.AddSpell(Heddframe,cfg.spells,"st",{3599}) -- Searing Totem
	cfg.notaoetotem = {}
	cfg.notaoetotem[cfg.spells["st"].name] = true
	lib.AddSpell(Heddframe,cfg.spells,"mt",{8190}) -- Magma Totem
	lib.AddSpell(Heddframe,cfg.spells,"fet",{2894}) -- Fire Elemental Totem
	lib.AddSpell(Heddframe,cfg.spells,"ftt",{8227}) -- Flametongue Totem
	cfg.aoetotem = {}
	cfg.aoetotem[cfg.spells["mt"].name] = true
	cfg.aoetotem[cfg.spells["fet"].name] = true
	cfg.aoetotem[cfg.spells["ftt"].name] = true
	lib.AddSpell(Heddframe,cfg.spells,"ue",{73680}) -- UE
	lib.AddSpell(Heddframe,cfg.spells,"mw",{53817},true,true) -- MW
	lib.AddSpell(Heddframe,cfg.spells,"lb",{403}) -- Lightning Bolt
	lib.AddSpell(Heddframe,cfg.spells,"cl",{421}) -- Chain Lightning

	cfg.auras={}
	lib.AddAura(cfg.auras,"ss",17364,"debuff","target") -- SS
	lib.AddAura(cfg.auras,"fs",8050,"debuff","target") -- FS
	lib.AddAura(cfg.auras,"uf",73683,"buff","player") -- Unleash Flame
	lib.AddAura(cfg.auras,"ls",324,"buff","player") -- LS
	lib.AddAura(cfg.auras,"ws",52127,"buff","player") -- Water Shield
	lib.AddAura(cfg.auras,"earth",974,"buff","player","any") -- Earth Shield
	lib.AddAura(cfg.auras,"mw",53817,"buff","player") -- MW
		
	lib.UpdateTotem(1)
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"ls")
	table.insert(cfg.plistdps,"firetotem")
	table.insert(cfg.plistdps,"ll")
	table.insert(cfg.plistdps,"ss_new")
	table.insert(cfg.plistdps,"fs_uf")
	table.insert(cfg.plistdps,"lb_mw")
	table.insert(cfg.plistdps,"ue")
	table.insert(cfg.plistdps,"ss")
	table.insert(cfg.plistdps,"es")
	table.insert(cfg.plistdps,"sw")
	table.insert(cfg.plistdps,"end")
		
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"ls")
	table.insert(cfg.plistaoe,"cl_mw")
	table.insert(cfg.plistaoe,"firetotem")
	table.insert(cfg.plistaoe,"fs_aoe")
	table.insert(cfg.plistaoe,"ue")
	table.insert(cfg.plistaoe,"fn")
	table.insert(cfg.plistaoe,"ss")
	table.insert(cfg.plistaoe,"ll")
	table.insert(cfg.plistaoe,"es")
	table.insert(cfg.plistaoe,"sw")
	table.insert(cfg.plistaoe,"end")
		
	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["firetotem"] = function()
			local t = lib.GetTotem(1)
			if t<3 then
				--return lib.UseTotem(cfg.totems[1],"st")
				return lib.SimpleCDCheck("st")
			end
			return nil
		end,
		["ls"] = function ()
			local t = lib.GetAura({"earth","ws","ls"})
			if t<3 then
				return lib.SimpleCDCheck("ls")
			end
			return nil
		end,
		["ll"] = function ()
			return lib.SimpleCDCheck("ll")
		end,
		["fs_uf"] = function ()
			local t = lib.GetAura({"uf"})
			if t>0 then
				--return lib.ApplyonAura("fs","uf")
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["fs_aoe"] = function ()
			local t = lib.GetAura({"fs"})
			if t==0 then
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["es"] = function ()
			return lib.SimpleCDCheck("es")
		end,
		["lb_mw"] = function ()
			local t,s = lib.GetAura({"mw"})
			if t>0 and s==5 then
				--return lib.ApplyonAura("lb","mw",5)
				return lib.SimpleCDCheck("lb")
			end
			return nil
		end,
		["cl_mw"] = function ()
			local t,s = lib.GetAura({"mw"})
			if t>0 and s==5 then
				return lib.SimpleCDCheck("cl")
			end
			return nil
		end,
		["ue"] = function ()
			return lib.SimpleCDCheck("ue")
		end,
		["fn"] = function ()
			local t = lib.GetTotem(1)
			if cfg.aoetotem[cfg.totems[1].totemName] and t>0 then
				return lib.SimpleCDCheck("fn")
			end
			return nil
		end,
		["ss_new"] = function ()
			local t = lib.GetAura({"ss"})
			if t==0 then
				return lib.SimpleCDCheck("ss")
			end
		end,
		["ss"] = function ()
			return lib.SimpleCDCheck("ss")
		end,
		["sw"] = function ()
			return lib.SimpleCDCheck("sw")
		end,
		["end"] = function ()
			if cfg.cmintime~=9999999 then return nil end
		end,
	}

	cfg.numcase=0
	for key, value in pairs(cfg.plistdps) do
		if cfg.case[value] then
			cfg.numcase=cfg.numcase+1
		end
	end
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			lib.SetPriority()
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			lib.SetPriority()
		end
		print(cfg.mode)
	end
	
	function Heddevents:PLAYER_TOTEM_UPDATE(self,...)
--		if (not cfg.spells["st"]) then return end
		if lib.UpdateTotem(1) then
			if cfg.notaoetotem[cfg.totems[1].totemName] and cfg.mode~="dps" then
				cfg.mode = "dps"
				cfg.plist=cfg.plistdps
				print(cfg.mode)
			elseif cfg.aoetotem[cfg.totems[1].totemName] and cfg.mode~="aoe" then
				cfg.mode = "aoe"
				cfg.plist=cfg.plistaoe
				print(cfg.mode)
			end
			lib.SetPriority()
		end
	end
	
	lib.rangecheck=function()
		if lib.inrange("ss") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("lb") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	lib.mypew = function()
		return lib.UpdateTotem(1)
	end
	
	lib.myonupdate = function()
		lib.rangecheck()
	end
	
	cfg.onupdate=true
	
	return true
end

lib.classevents["SHAMAN"] = function()
	function Heddevents:PLAYER_TOTEM_UPDATE(...)
--		if (not cfg.spells["st"]) then return end
--		print(...)
		if lib.UpdateTotem(1) then
			if cfg.notaoetotem[cfg.totems[1].totemName] and cfg.mode~="dps" then
				cfg.mode = "dps"
				cfg.plist=cfg.plistdps
				print(cfg.mode)
			elseif cfg.aoetotem[cfg.totems[1].totemName] and cfg.mode~="aoe" then
				cfg.mode = "aoe"
				cfg.plist=cfg.plistaoe
				print(cfg.mode)
			end
			lib.SetPriority()
		end
	end
end